您的位置:首页 > 其它

HDU 1394 Minimum Inversion Number(用规律取代线段树)

2016-07-21 21:23 441 查看
Problem DescriptionThe inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:a1, a2, ..., an-1, an (where m = 0 - the initial seqence)a2, a3, ..., an, a1 (where m = 1)a3, a4, ..., an, a1, a2 (where m = 2)...an, a1, a2, ..., an-1 (where m = n-1)You are asked to write a program to find the minimum inversion number out of the above sequences. InputThe input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1. OutputFor each case, output the minimum inversion number on a single line. Sample Input
101 3 6 9 0 8 5 7 4 2 Sample Output
16 AuthorCHEN, Gaoli SourceZOJ Monthly, January 2003 
题意:	开始不知道什么是逆序数列,百度之后才知道。。。	意思就是说数列1    3      2      5      4     0里面	(1,0)(3,2)(3,0)(2,0)(5,4)(4,0)有6对	满足的i<j而ai>aj的数对	题目给出一个数列,可以将第一个数放到数列尾部	这样循环n次可以得到n组数列	求这n组里面的最小逆序数分析:	样例模拟一遍,发现规律:
如果是0到n的排列,那么如果把第一个数放到最后,
对于这个数列,逆序数是减少a[i],而增加n-1-a[i]
所以直接找到输入数列的逆序数,然后一个循环即可找出所有数列的逆序数
至于第一组的找法,表示n只有5*10^3,故一个二重循环搞定。。。
另外,这题被分类为线段树。。。。暴力过了。。。。。
#include<cstdio>#include<algorithm>using namespace std;const int N = 5000;int a[N + 5];int main(){int n;while (~scanf("%d",&n)){for (int i = 1;i <= n;++i) scanf("%d",&a[i]);int sun = 0;for (int i = 1;i <= n;++i)for (int j = i+1;j <= n;++j)if (a[j] < a[i]) sun++;int ans = sun;for (int i = 1;i <= n;++i){sun = sun - a[i] + (n-1-a[i]);ans = min(ans,sun);}printf("%d\n",ans);}return 0;}
                                            
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  hdu 暴力